// SetupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "gariki_next_step.h"
#include "SetupDlg.h"
#include "Gariki.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg dialog


CSetupDlg::CSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupDlg)
	m_bMinutesShow = FALSE;
	m_uMinutes = 0;
	//}}AFX_DATA_INIT
}


void CSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupDlg)
	DDX_Control(pDX, IDC_TREE1, m_pTreeCtrl);
	DDX_Check(pDX, IDC_VIEW, m_bMinutesShow);
	DDX_Text(pDX, IDC_EDIT2, m_uMinutes);
	DDV_MinMaxUInt(pDX, m_uMinutes, 1, 1440);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CSetupDlg)
	ON_NOTIFY(TVN_GETDISPINFO, IDC_TREE1, OnGetDispinfo)
	ON_BN_CLICKED(IDC_VIEW, OnMinutesShow)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE1, OnSelchangedTree)
	ON_WM_DESTROY()
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg message handlers

BOOL CSetupDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	InitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSetupDlg::InitDialog()
{
	TCHAR str[255];
	int IdCheckButton;
//     
  SetWindowText("  ");
  SetDlgItemText(IDC_SERIAL,"");
//      
	::SendMessage(::GetDlgItem(m_hWnd,IDC_SPIN1),UDM_SETRANGE,0,
		(LPARAM) MAKELONG((short) 1440, (short) 1));
	::EnableWindow(::GetDlgItem(m_hWnd,IDC_EDIT2),Show);
	sprintf(str,"%u",MinutesShow);

	SetDlgItemText(IDC_EDIT2,str );
  SetDlgItemText(IDC_RANDOM,"");
  SetDlgItemText(IDC_VIEW,"  ");
  SetDlgItemText(IDC_GARIKISELECT,"   ");
  SetDlgItemText(IDC_EVERY,"");
  SetDlgItemText(IDC_MIN,"");
//   " "
	SendDlgItemMessage(IDC_VIEW,BM_SETCHECK,(WPARAM) Show, 0);

	if (RandSet) 
		IdCheckButton = IDC_RANDOM;
	else 
		IdCheckButton = IDC_SERIAL;
	::CheckRadioButton(m_hWnd, IDC_SERIAL, IDC_RANDOM, IdCheckButton);

//   !!!
	HWND hWndTree = ::GetDlgItem(m_hWnd,IDC_TREE1);
	int i,
		ItemNo = 0,
		Level;
	for (i = edBook; i<=ZakatBook; i++)
	{	// 
		if ((i == edBook) ||  //    
			  (i == ZakatBook) || //  
			  (i == igBook))    //  
	       Level = 1;
		else
		 if ((i == edVolume1) || 
			 (i == edVolume2) ||
				(i == igChapter3_1) ||
				(i == igChapter3_2))
			     Level = 2;
		 else
			 Level = i;
		LoadResourceString(i,str,254);
		AddItemToTree(hWndTree,str, Level, ItemNo++);
	};
	InitTreeViewImageLists();
}

// AddItemToTree - adds items to a tree-view control. 
HTREEITEM CSetupDlg::AddItemToTree(HWND hwndTV, LPSTR lpszItem, int nLevel,
						int lParam) 
{ 
    TV_ITEM tvi; 
    TV_INSERTSTRUCT tvins; 
    static HTREEITEM hPrev = (HTREEITEM) TVI_FIRST; 
    static HTREEITEM hPrevRootItem = NULL; 
    static HTREEITEM hPrevLev2Item = NULL; 
    HTREEITEM hti; 


    tvi.mask = TVIF_TEXT | TVIF_IMAGE 
        | TVIF_SELECTEDIMAGE | TVIF_PARAM ;//| TVIF_STATE; 
 
    // Set the text of the item. 
    tvi.pszText = lpszItem; 
    tvi.cchTextMax = lstrlen(lpszItem); 
 
    // Assume the item is not a parent item, so give it a 

    // document image. 
    tvi.iImage = I_IMAGECALLBACK;//g_nDocument; 
    tvi.iSelectedImage = I_IMAGECALLBACK;//g_nDocument; 

    // Save the heading level in the item's application-defined 
    // data area. 
    tvi.lParam = lParam; 
 
    tvins.item = tvi; 
    tvins.hInsertAfter = hPrev; 
 
    // Set the parent item based on the specified level. 
    if (nLevel == 1) 
        tvins.hParent = TVI_ROOT; 
    else if (nLevel == 2) 
        tvins.hParent = hPrevRootItem; 
    else 

        tvins.hParent = hPrevLev2Item; 
 
    // Add the item to the tree-view control. 
    hPrev = (HTREEITEM) ::SendMessage(hwndTV, TVM_INSERTITEM, 0, 
         (LPARAM) (LPTV_INSERTSTRUCT) &tvins); 
 
    // Save the handle of the item. 
    if (nLevel == 1) 
        hPrevRootItem = hPrev; 
    else if (nLevel == 2) 
        hPrevLev2Item = hPrev; 
 
    // The new item is a child item. Give the parent item a 
    // closed folder bitmap to indicate it now has child items. 

    if (nLevel > 1) { 
        hti = TreeView_GetParent(hwndTV, hPrev); 
        tvi.mask = TVIF_IMAGE | TVIF_SELECTEDIMAGE; 
        tvi.hItem = hti; 
        tvi.iImage = I_IMAGECALLBACK;//g_nClosed; 
        tvi.iSelectedImage = I_IMAGECALLBACK;//g_nOpen; 
        TreeView_SetItem(hwndTV, &tvi); 
    } 
//  
	if (lParam == CurTopic)
			TreeView_SelectItem(hwndTV,hPrev);
 
    return hPrev; 
} 

BOOL CSetupDlg::InitTreeViewImageLists() 
{ 
 	TreeImgList.Create(IDB_TREEPICT,17,3,RGB(0,0,128));
	m_pTreeCtrl.SetImageList(&TreeImgList,TVSIL_NORMAL);

  return TRUE; 
} 

void CSetupDlg::OnGetDispinfo(NMHDR* pNMHDR, LRESULT* pResult) 
{
	TV_DISPINFO* ptvdi = (TV_DISPINFO*)pNMHDR;
	//     
	TV_ITEM *item = &(ptvdi->item);

	if ((item->lParam == 0) || 
		(item->lParam == ZakatBook-edBook))
		if (item->state & TVIS_EXPANDED)
		{	item->iImage = 0;
			item->iSelectedImage = 0;
		}
		else
		{	item->iImage = 1;
			item->iSelectedImage = 1;
		}
	else
	{	item->iImage = 2;
		item->iSelectedImage = 2;
	};

	*pResult = 1;
}

void CSetupDlg::OnMinutesShow() 
{
	UpdateData(TRUE);	
	
	::EnableWindow(::GetDlgItem(m_hWnd,IDC_EDIT2),m_bMinutesShow);
}

void CSetupDlg::OnSelchangedTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	m_NewTopic = pNMTreeView->itemNew.lParam;
	
	*pResult = 1;
}

void CSetupDlg::OnDestroy() 
{
	if (BST_CHECKED	== IsDlgButtonChecked(IDC_RANDOM))
			m_RandSet = TRUE;
	else
			m_RandSet = FALSE;
	
	CDialog::OnDestroy();
}

BOOL CSetupDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if (pHelpInfo->iContextType == HELPINFO_WINDOW)
	{
		return HtmlHelp(	(HWND)pHelpInfo->hItemHandle,AfxGetApp()->m_pszHelpFilePath,
						HH_HELP_CONTEXT, IDH_SETSHOW) != NULL;
	}
	return TRUE;
//	return CDialog::OnHelpInfo(pHelpInfo);
}
