// SetupView.cpp : implementation file
//

#include "stdafx.h"
#include "gariki_next_step.h"
#include "SetupView.h"
#include "StihWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//   ,       
//       
//     :)
static TCHAR BASED_CODE szCaption[] = _T("  ");

static TCHAR BASED_CODE szBtnFont[] = _T("");
static TCHAR BASED_CODE szBtnBkColor[] = _T(" ");
static TCHAR BASED_CODE szBtnTxtColor[] = _T(" ");

static TCHAR BASED_CODE szBtnDoChange[] = _T("");
static TCHAR BASED_CODE szBtnCancel[] = _T("");

/////////////////////////////////////////////////////////////////////////////
// CSetupView dialog


CSetupView::CSetupView(CWnd* pParent /*=NULL*/)
	: CDialog(CSetupView::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupView)
	m_CurFont = _T("");
	//}}AFX_DATA_INIT
	m_pStihWnd = (CStihWnd *)pParent;
}


void CSetupView::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupView)
	DDX_Control(pDX, IDC_COLORS, m_sColors);
	DDX_Control(pDX, IDC_DOCHANGES, m_DoChanges);
	DDX_Text(pDX, IDC_FONT_TXT, m_CurFont);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupView, CDialog)
	//{{AFX_MSG_MAP(CSetupView)
	ON_BN_CLICKED(IDC_FONT_BTN, OnFontBtn)
	ON_BN_CLICKED(IDC_BKCOLOR_BTN, OnBkcolorBtn)
	ON_BN_CLICKED(IDC_TXTCOLOR_BTN, OnTxtcolorBtn)
	ON_BN_CLICKED(IDC_DOCHANGES, OnDoChanges)
	ON_WM_PAINT()
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupView message handlers
BOOL CSetupView::OnInitDialog() 
{
	CDialog::OnInitDialog();
  //    
	m_pStihWnd->GetPropertis(m_CurLogFont,m_BkColor,m_TxtColor);

	m_CurFont.Format("%s", m_CurLogFont.lfFaceName);
	m_DoChanges.SetState(FALSE);
	UpdateData(FALSE);

	m_DoChanges.EnableWindow(FALSE);

	SetWindowText(szCaption);
	
	SetDlgItemText(IDC_FONT_BTN,szBtnFont);
	SetDlgItemText(IDC_BKCOLOR_BTN,szBtnBkColor);
	SetDlgItemText(IDC_TXTCOLOR_BTN,szBtnTxtColor);
	
	SetDlgItemText(IDC_DOCHANGES,szBtnDoChange);
	SetDlgItemText(IDCANCEL,szBtnCancel);

	CenterWindow(GetDesktopWindow());

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSetupView::OnFontBtn() 
{
	CFontDialog dlg(&m_CurLogFont,CF_SCREENFONTS);

  if (dlg.DoModal() == IDOK) 
	{
    dlg.GetCurrentFont(&m_CurLogFont);
		m_CurLogFont.lfCharSet = RUSSIAN_CHARSET;
		m_CurFont.Format("%s", m_CurLogFont.lfFaceName);
    UpdateData(FALSE);
		m_DoChanges.EnableWindow();
		Invalidate(FALSE);
	};  
}

void CSetupView::OnBkcolorBtn() 
{
	CColorDialog dlg(m_BkColor);
	
	if (dlg.DoModal() == IDOK)
	{
   m_BkColor= dlg.GetColor();
	 Invalidate(FALSE);
	 m_DoChanges.EnableWindow();
	 Invalidate(FALSE);
  }
	
}

void CSetupView::OnTxtcolorBtn() 
{
	CColorDialog dlg(m_BkColor);
	
	if (dlg.DoModal() == IDOK)
	{
   m_TxtColor = dlg.GetColor();
	 Invalidate(FALSE);
	 m_DoChanges.EnableWindow();
	 Invalidate(FALSE);
  }
}

void CSetupView::OnDoChanges() 
{
	m_pStihWnd->SetPropertis(m_CurLogFont,m_BkColor,m_TxtColor);
	m_DoChanges.EnableWindow(FALSE);	
}

int CSetupView::DoModal() 
{
	int res = CDialog::DoModal();
	
	if (res == IDOK)
		m_pStihWnd->SetPropertis(m_CurLogFont,m_BkColor,m_TxtColor);

	return res;
}

void CSetupView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CPaintDC ItemDC(&m_sColors);
	RECT rect;
	HFONT NewFont,OldFont;
	NewFont = ::CreateFontIndirect(&m_CurLogFont);
	m_sColors.GetClientRect(&rect);

	::FillRect(ItemDC.m_hDC,&rect,::CreateSolidBrush(m_BkColor));
	ItemDC.SetBkMode(TRANSPARENT);
	ItemDC.SetTextColor(m_TxtColor);

	OldFont = (HFONT)::SelectObject(ItemDC.m_hDC,NewFont);
	
	ItemDC.DrawText(m_CurLogFont.lfFaceName,strlen(m_CurLogFont.lfFaceName),&rect,DT_SINGLELINE | DT_CENTER | DT_VCENTER);
	
	::SelectObject(ItemDC.m_hDC,OldFont);
	::DeleteObject(NewFont);
	// Do not call CDialog::OnPaint() for painting messages
}

BOOL CSetupView::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if (pHelpInfo->iContextType == HELPINFO_WINDOW)
	{
		return HtmlHelp(	(HWND)pHelpInfo->hItemHandle,AfxGetApp()->m_pszHelpFilePath,
						HH_HELP_CONTEXT, IDH_SETVIEW) != NULL;
	}
	return TRUE;	
//	return CDialog::OnHelpInfo(pHelpInfo);
}
