// SkinDlg.cpp : implementation file
//

#include "stdafx.h"
#include "gariki_next_step.h"
#include "SkinDlg.h"
#include "ToolWnd.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static TCHAR BASED_CODE szTitle[] = _T(" ");
static TCHAR BASED_CODE szDefButton[] = _T(" ");
static TCHAR BASED_CODE szLoadButton[] = _T(" ...");
static TCHAR BASED_CODE szSetBmp[]  = _T("   ");
static TCHAR BASED_CODE szApplayButton[]  = _T("");

/////////////////////////////////////////////////////////////////////////////
// CSkinDlg dialog
CSkinDlg::CSkinDlg(CToolWnd* pParent,CString *SkinFilePath)
	: CDialog(CSkinDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSkinDlg)
	m_editFileName = _T("");
	//}}AFX_DATA_INIT
	m_pParentWnd = pParent;

	FileName = *SkinFilePath;
}


void CSkinDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSkinDlg)
	DDX_Control(pDX, IDC_APPLY, m_Apply);
	DDX_Control(pDX, IDC_CURSKIN, m_CurSkin);
	DDX_Text(pDX, IDC_FILENAME, m_editFileName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSkinDlg, CDialog)
	//{{AFX_MSG_MAP(CSkinDlg)
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_EN_CHANGE(IDC_FILENAME, OnChangeFilename)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSkinDlg message handlers
void CSkinDlg::OnDefault() 
{
	CBitmap ToolBmp;
	
	ToolBmp.LoadBitmap(IDR_TOOLBAR1);
	
	m_CurSkin.SetBitmap((HBITMAP)ToolBmp.m_hObject);
	if (!FileName.IsEmpty())
		m_Apply.EnableWindow(TRUE);
	
	ToolBmp.Detach();
	FileName.Empty();

	m_editFileName = FileName;
	UpdateData(FALSE);
}
void CSkinDlg::OnLoad()
{
	CFileDialog *fd = new CFileDialog(TRUE,"*.bmp",NULL,
					OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_FILEMUSTEXIST, "Bitmap Files (*.bmp)|*.bmp||",this);
	if (fd->DoModal() == IDOK)
	{
		//  
		CString locFileName = fd->GetPathName();
		
		if (SetCurSkinBmp(locFileName))
			FileName = locFileName;
		
		m_editFileName = FileName;
		UpdateData(FALSE);
	};
}

int CSkinDlg::DoModal() 
{
	int Res = CDialog::DoModal();

	if (Res == IDOK)
		ApplyNewSkin();
	
	return Res;
}

void CSkinDlg::ApplyNewSkin()
{
	if (m_editFileName.IsEmpty())
	{
		m_pParentWnd->m_wndDockBar.SetBtnSkinRes(IDR_TOOLBAR1,9);
	}
	else
	{
		m_pParentWnd->m_wndDockBar.SetBtnSkinFile(m_editFileName,9);
	};
}

BOOL CSkinDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if (!FileName.IsEmpty())
		SetCurSkinBmp(FileName);

	m_editFileName = FileName;
	UpdateData(FALSE);
	
	m_Apply.EnableWindow(FALSE);
	
	SetWindowText(szTitle);
	SetDlgItemText(IDC_DEFAULT,szDefButton);
	SetDlgItemText(IDC_LOAD,szLoadButton);
	SetDlgItemText(IDC_XYZ,szSetBmp);
	SetDlgItemText(IDC_APPLY,szApplayButton);

	return TRUE; 
}



void CSkinDlg::OnApply() 
{	
	UpdateData(TRUE);
	ApplyNewSkin();
	m_Apply.EnableWindow(FALSE);
}
//          m_CurSkin
BOOL CSkinDlg::SetCurSkinBmp(CString &FileName)
{
	CRect CurRect;
	m_CurSkin.GetWindowRect(&CurRect);
	
	char path[500];
	int PathLen;
	//      ,    
	//   
	::GetModuleFileName(NULL,path,500);
	char *tmp = strrchr(path,'\\');
	path[tmp - path] = 0;
	
	_strlwr(path);
	FileName.MakeLower();
	PathLen = strlen(path);
	//       .
	if (!memcmp(FileName,path,PathLen))
			FileName.Delete(0,PathLen+1);


	HBITMAP hBmp = (HBITMAP) LoadImage(AfxGetInstanceHandle(),(LPCSTR)FileName,IMAGE_BITMAP,
														CurRect.Width(),CurRect.Height(),LR_LOADFROMFILE);
	if (hBmp != NULL)
	{	
		m_CurSkin.SetBitmap(hBmp);
		m_Apply.EnableWindow(TRUE);
	}
	else
	{
		CString ErrStr;
		ErrStr.Format("    %s   ",FileName);
		AfxMessageBox(ErrStr);
		FileName.Empty();
		return FALSE;
	};
	return TRUE;
}

void CSkinDlg::OnChangeFilename() 
{
	UpdateData(TRUE);
	m_Apply.EnableWindow(TRUE);
}

BOOL CSkinDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if (pHelpInfo->iContextType == HELPINFO_WINDOW)
	{
		return HtmlHelp(	(HWND)pHelpInfo->hItemHandle,AfxGetApp()->m_pszHelpFilePath,
						HH_HELP_CONTEXT, IDH_SETSKIN) != NULL;
	}
	return TRUE;
	//return CDialog::OnHelpInfo(pHelpInfo);
}
