// ToolWnd.cpp : implementation file
//

#include "stdafx.h"
#include "Gariki_Next_Step.h"
#include "editbar.h"
#include "ToolWnd.h"
#include "WndUtils.h"
#include "StihWnd.h"
#include "gariki.h"
#include "SetupDlg.h"
#include "About.h"
#include "SkinDlg.h"
#include "garikihelp.h"

#ifdef _DEBUG
#define new DEBUG_NEW  
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static TCHAR BASED_CODE szSection[] = _T("Tool Wnd Settings");

static TCHAR szMainSection[] = _T("Main");
static TCHAR szCurStih[] = _T("Cur Stih");
static TCHAR szRandSet[] = _T("Random Set");
static TCHAR szCurTopic[] = _T("Current Topic");
static TCHAR szAutoShow[] = _T("Auto Show");
static TCHAR szMinutes[] = _T("Minutes Show");
static TCHAR szSkinPath[] = _T("Btn Skin Path");

#if 0
	static TCHAR szTopMost[] = _T("Top Most");
	static TCHAR szStihVisible[] = _T("Stih Visible");
	static TCHAR szToolVisible[] = _T("Tool Visible");  
#endif
//       
#define IDT_SHOWTIMER 7890
// ,    
#define SECUNDA 60000

/////////////////////////////////////////////////////////////////////////////
// CToolWnd


IMPLEMENT_DYNCREATE(CToolWnd, CMiniFrameWnd)

CToolWnd::CToolWnd() //: m_wndDockBar(TRUE)
{
	m_wndDockBar.m_bAutoDelete = FALSE;
	// ,    
	m_ParentTopMost = FALSE;
	//      . 
	m_nShowTimer = 0; 
}

CToolWnd::~CToolWnd()
{
}


BEGIN_MESSAGE_MAP(CToolWnd, CMiniFrameWnd)
	//{{AFX_MSG_MAP(CToolWnd)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	ON_WM_NCLBUTTONDOWN()
	ON_WM_NCLBUTTONDBLCLK()
	ON_WM_MOUSEACTIVATE()
	ON_COMMAND(ID_BACK, OnBack)
	ON_UPDATE_COMMAND_UI(ID_TOP_MOST, OnUpdateTopMost)
	ON_COMMAND(ID_TOP_MOST, OnTopMost)
	ON_COMMAND(ID_HIDE, OnHide)
	ON_COMMAND(ID_COPY, OnStihCopy)
	ON_COMMAND(ID_NEXT, OnNext)
	ON_UPDATE_COMMAND_UI(ID_BACK, OnUpdateBack)
	ON_UPDATE_COMMAND_UI(ID_NEXT, OnUpdateNext)
	ON_COMMAND(ID_SETUP, OnSetup)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_COMMAND(ID_FIND, OnFind)
	ON_UPDATE_COMMAND_UI(ID_FIND, OnUpdateFind)
	ON_COMMAND(ID_ABOUT, OnAbout)
	ON_WM_QUERYENDSESSION()
	ON_COMMAND(ID_SKINS, OnSkins)
	ON_COMMAND(ID_NEXT_SEARCH, OnNext)
	ON_UPDATE_COMMAND_UI(ID_NEXT_SEARCH, OnUpdateNext)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToolWnd message handlers

int CToolWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMiniFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	//  
	WINDOWPLACEMENT wp;
	if (ReadWindowPlacement(szSection,&wp))
		MoveWindow(&wp.rcNormalPosition);	
		
	return 0;
}

BOOL CToolWnd::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	cs.style |= WS_MINIMIZE | WS_CAPTION;
	return CMiniFrameWnd::PreCreateWindow(cs);
}

///////////////////////////////////////////////////////////////


int CToolWnd::OnMouseActivate(CWnd* pDesktopWnd, UINT nHitTest, UINT message)
{
	if (nHitTest >= HTSIZEFIRST && nHitTest <= HTSIZELAST) // resizing
		return MA_NOACTIVATE;
	return CMiniFrameWnd::OnMouseActivate(pDesktopWnd, nHitTest, message);
}


BOOL CToolWnd::Create(CWnd* pParent, DWORD dwBarStyle)
{
	// set m_bInRecalcLayout to avoid flashing during creation
	// RecalcLayout will be called once something is docked
	m_bInRecalcLayout = TRUE;

	DWORD dwStyle = WS_POPUP|WS_CAPTION|WS_SYSMENU|MFS_MOVEFRAME|
		MFS_4THICKFRAME|MFS_SYNCACTIVE|MFS_BLOCKSYSMENU|
		FWS_SNAPTOBARS;

	if (dwBarStyle & CBRS_SIZE_DYNAMIC)
		dwStyle &= ~MFS_MOVEFRAME;

	DWORD dwExStyle = 0;
	if (!CMiniFrameWnd::CreateEx(dwExStyle,
		NULL, &afxChNil, dwStyle, rectDefault, pParent))
	{
		m_bInRecalcLayout = FALSE;
		return FALSE;
	}
	//    ,   
	m_pStihWnd = (CStihWnd *) pParent;

	dwStyle = dwBarStyle & (CBRS_ALIGN_LEFT|CBRS_ALIGN_RIGHT) ?
		CBRS_ALIGN_LEFT : CBRS_ALIGN_TOP;
	dwStyle |= dwBarStyle & CBRS_FLOAT_MULTI;
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	pSysMenu->DeleteMenu(SC_SIZE, MF_BYCOMMAND);
	pSysMenu->DeleteMenu(SC_MINIMIZE, MF_BYCOMMAND);
	pSysMenu->DeleteMenu(SC_MAXIMIZE, MF_BYCOMMAND);
	pSysMenu->DeleteMenu(SC_RESTORE, MF_BYCOMMAND);

	// must initially create with parent frame as parent
	//	if (!m_wndDockBar.Create(pParent, WS_CHILD | WS_VISIBLE | dwStyle,
	//	AFX_IDW_DOCKBAR_FLOAT))
	if (!m_wndDockBar.Init(this,TRUE,TRUE))
	{
		m_bInRecalcLayout = FALSE;
		return FALSE;
	}

	// set parent to CToolWnd
	m_wndDockBar.SetParent(this);
	m_bInRecalcLayout = FALSE;
	//  
	ReadMainSettings(szMainSection);
	//           
	if (m_pStihWnd)
		SetNewContent(CurStih,CurTopic);
	//      ?
	if (m_ParentTopMost)
			OnTopMost();
	//       ?
	if (Show)
	{	if (!m_ParentTopMost) 
			OnTopMost();
		SetShowTimer();
	};
	
	LoadAccelTable(MAKEINTRESOURCE(IDR_ACCELERATOR));
	
	return TRUE;
}

void CToolWnd::RecalcLayout(BOOL bNotify)
{
	if (!m_bInRecalcLayout)
	{
		CMiniFrameWnd::RecalcLayout(bNotify);

		// syncronize window text of frame window with dockbar itself
		TCHAR szTitle[_MAX_PATH];
		m_wndDockBar.GetWindowText(szTitle, _MAX_PATH-1);//_countof(szTitle));
		SetWindowText(szTitle);
	}
}

void CToolWnd::OnClose()
{
	//  
	m_pStihWnd->ShowWindow(SW_HIDE);  
	m_pStihWnd->PostMessage(WM_CLOSE);//OnClose();//CloseWindow();
	
	CMiniFrameWnd::OnClose();
}

void CToolWnd::OnNcLButtonDown(UINT nHitTest, CPoint point)
{/*
	if (nHitTest == HTCAPTION)
	{
		// special activation for floating toolbars
		ActivateTopParent();

		// initiate toolbar drag for non-CBRS_FLOAT_MULTI toolbars
		if ((m_wndDockBar.m_dwStyle & CBRS_FLOAT_MULTI) == 0)
		{
			int nPos = 1;
			CControlBar* pBar = NULL;
			while(pBar == NULL && nPos < m_wndDockBar.m_arrBars.GetSize())
				pBar = m_wndDockBar.GetDockedControlBar(nPos++);

			ASSERT(pBar != NULL);
			ASSERT_KINDOF(CControlBar, pBar);
			ASSERT(pBar->m_pDockContext != NULL);
			pBar->m_pDockContext->StartDrag(point);
			return;
		}
	}
	else if (nHitTest >= HTSIZEFIRST && nHitTest <= HTSIZELAST)
	{
		// special activation for floating toolbars
		ActivateTopParent();

		int nPos = 1;
		CControlBar* pBar = NULL;
		while(pBar == NULL && nPos < m_wndDockBar.m_arrBars.GetSize())
			pBar = m_wndDockBar.GetDockedControlBar(nPos++);

		ASSERT(pBar != NULL);
		ASSERT_KINDOF(CControlBar, pBar);
		ASSERT(pBar->m_pDockContext != NULL);

		// CBRS_SIZE_DYNAMIC toolbars cannot have the CBRS_FLOAT_MULTI style
		ASSERT((m_wndDockBar.m_dwStyle & CBRS_FLOAT_MULTI) == 0);
		pBar->m_pDockContext->StartResize(nHitTest, point);
		return;
	}*/
	CMiniFrameWnd::OnNcLButtonDown(nHitTest, point);
}

void CToolWnd::OnNcLButtonDblClk(UINT nHitTest, CPoint point)
{/*
	if (nHitTest == HTCAPTION)
	{
		// special activation for floating toolbars
		ActivateTopParent();

		// initiate toolbar toggle for non-CBRS_FLOAT_MULTI toolbars
		if ((m_wndDockBar.m_dwStyle & CBRS_FLOAT_MULTI) == 0)
		{
			int nPos = 1;
			CControlBar* pBar = NULL;
			while(pBar == NULL && nPos < m_wndDockBar.m_arrBars.GetSize())
				pBar = m_wndDockBar.GetDockedControlBar(nPos++);

			ASSERT(pBar != NULL);
			ASSERT_KINDOF(CControlBar, pBar);
			ASSERT(pBar->m_pDockContext != NULL);
			pBar->m_pDockContext->ToggleDocking();
			return;
		}
	}
	*/
	CMiniFrameWnd::OnNcLButtonDblClk(nHitTest, point);
}
//  
void CToolWnd::OnBack() 
{
	On_Back(NULL);
	
	SetNewContent(CurStih,-1);
	if(Show)
		SetShowTimer();
}
//  
void CToolWnd::OnNext() 
{
	On_More(NULL);

	SetNewContent(CurStih,-1);
	if(Show)
		SetShowTimer();
}
void CToolWnd::OnUpdateTopMost(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_ParentTopMost);	
}

void CToolWnd::OnTopMost() 
{
	m_ParentTopMost = !m_ParentTopMost;
		
	if (m_ParentTopMost)
		m_pStihWnd->SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
	else
		m_pStihWnd->SetWindowPos(&wndNoTopMost,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
}

void CToolWnd::OnHide() 
{
	ShowWindow(SW_HIDE);
	if (!m_ParentTopMost)
	{	
		m_pStihWnd->ShowWindow(SW_HIDE);
	};
};
//     (m_pStihWnd->m_CurStih)
void CToolWnd::OnStihCopy() 
{
	m_pStihWnd->SendMessage(WM_COMMAND,ID_COPY,0);
}

//    
void CToolWnd::OnUpdateBack(CCmdUI* pCmdUI) 
{
	BOOL Enable = TRUE;

	if ((CurStih <= TopicInfo[CurTopic].first) ||
		   (eFindMode != Off) ||
			 RandSet)
		Enable = FALSE;

	pCmdUI->Enable(Enable);
}
//    !
void CToolWnd::OnUpdateNext(CCmdUI* pCmdUI) 
{
	BOOL Enable = TRUE;

	if ((CurStih >= TopicInfo[CurTopic].first + TopicInfo[CurTopic].stihQty) ||
		  (eFindMode == OnLastFinded))
		Enable = FALSE;

	pCmdUI->Enable(Enable);
}
//     
//nIDStih -      , nTopicNo -   ( 0)
// -   -1,    
void CToolWnd::SetNewContent(int nIDStih, int nTopicNo, BOOL Flash)
{
	if (nIDStih != -1)
	{
		char pszBuf[500];
		LoadResourceString(CurStih,pszBuf,499);
		m_pStihWnd->SetNewStih(CString(pszBuf),Flash);
	};
};

void CToolWnd::OnSetup() 
{
	if (AnyDialogShow)
		return;
	
	AnyDialogShow = TRUE;
	CSetupDlg SetupDlg;
	
	if (m_nShowTimer)
	{
		KillTimer(m_nShowTimer);
		m_nShowTimer = 0;
	};

	if (SetupDlg.DoModal() == IDOK)
	{
		
		if (eFindMode == Off)
		{	MinutesShow = SetupDlg.m_uMinutes;
			RandSet = SetupDlg.m_RandSet;
	
			if (SetNewTopic(SetupDlg.m_NewTopic))
				SetNewContent(CurStih,CurTopic);
			//    " "
			Show = SetupDlg.m_bMinutesShow;
			if (Show)
			{
				if (!m_ParentTopMost)
					OnTopMost();
				SetShowTimer();
			};
		};
	};
	AnyDialogShow = FALSE;
}

//   curStih, CurTopic  .  
//   szSection
void CToolWnd::WriteMainSettings(LPCSTR szSection)
{
	//    ,    
	if (eFindMode != Off)
		return;
	//    
	AfxGetApp()->WriteProfileInt(szSection, szCurStih, CurStih);
	//   \
	AfxGetApp()->WriteProfileInt(szSection, szRandSet, RandSet);
	 //   
	AfxGetApp()->WriteProfileInt(szSection, szCurTopic, CurTopic);
	//   
	AfxGetApp()->WriteProfileInt(szSection, szAutoShow, Show);
	//       
	AfxGetApp()->WriteProfileInt(szSection, szMinutes, MinutesShow);
	//    
	AfxGetApp()->WriteProfileString(szSection, szSkinPath, m_wndDockBar.GetBtnSkinFilePath());
}
//   curStih, CurTopic  .  
//   szSection
void CToolWnd::ReadMainSettings(LPCSTR szSection)
{ 
	//   
	int l_CurTopic = AfxGetApp()->GetProfileInt(szSection, szCurTopic, CurTopic);
	if ((l_CurTopic>=0) && (l_CurTopic <= (ZakatBook - edBook)))
			CurTopic = l_CurTopic;

	//   
	int l_CurStih = AfxGetApp()->GetProfileInt(szSection, szCurStih, CurStih);
	if ((l_CurStih>=TopicInfo[CurTopic].first) && 
		(l_CurStih < (TopicInfo[CurTopic].first+ TopicInfo[CurTopic].stihQty)))
			CurStih = l_CurStih;
	else
			CurStih = TopicInfo[CurTopic].first;

	//   \
	if (AfxGetApp()->GetProfileInt(szSection, szRandSet, RandSet))
		RandSet = TRUE;
	else
		RandSet = FALSE;
	//   
	if (AfxGetApp()->GetProfileInt(szSection, szAutoShow, Show))
		Show = TRUE;
	else
		Show = FALSE;
	//       
	int l_MinShow = AfxGetApp()->GetProfileInt(szSection, szMinutes, MinutesShow);
	if ((l_MinShow<0) || (l_MinShow > 1440))
			l_MinShow = 1;
	MinutesShow = l_MinShow;
	//    
	CString SkinFilePath = AfxGetApp()->GetProfileString(szSection, szSkinPath, NULL);
	if (!SkinFilePath.IsEmpty())
		m_wndDockBar.SetBtnSkinFile(SkinFilePath,9);
};

void CToolWnd::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == IDT_SHOWTIMER)
	{
		if ((eFindMode != Off) || !(m_pStihWnd->IsWindowVisible()))
			return;
		On_WmTimer();
		if (!ScreenSaveActive)
			SetNewContent(CurStih,-1,TRUE);
	};

	CMiniFrameWnd::OnTimer(nIDEvent);
}
//       
void CToolWnd::SetShowTimer()
{
	if (m_nShowTimer)
	{
		KillTimer(m_nShowTimer);
		m_nShowTimer = 0;
	};

	m_nShowTimer = SetTimer(IDT_SHOWTIMER,SECUNDA*MinutesShow,NULL);
}

void CToolWnd::OnDestroy() 
{
	//  
	WriteMainSettings(szMainSection);
	//  
	WINDOWPLACEMENT wp;
	wp.length = sizeof wp;
	if (GetWindowPlacement(&wp))
	{
		wp.flags = 0;
		if (IsZoomed())
			wp.flags |= WPF_RESTORETOMAXIMIZED;
		// and write it to the .INI file
		WriteWindowPlacement(szSection,&wp);
	}

	CMiniFrameWnd::OnDestroy();
}

void CToolWnd::OnFind() 
{
 if (eFindMode == Off)
  {
		CString FindStr;

		m_wndDockBar.m_SearchBox.GetWindowText(FindStr);
		
		if (!FindStr.IsEmpty())
		{	
			if (FindStr.GetLength() < MAX_FINDTEXT_LEN)
			{
				strcpy(TextToFind, FindStr);
				LowerCase (TextToFind);
			}
			else
			{
				AfxMessageBox("  ");
				return;
			};
			
			WriteMainSettings(szMainSection);
			eFindMode = OnFirst;

			FindNext();
			//     - ?
			if (eFindMode == OnLastFinded)
				PostMessage(WM_COMMAND,ID_FIND,0);	// 
			else
			{
				m_wndDockBar.m_SearchBox.EnableWindow(FALSE);
				SetNewContent(CurStih,CurTopic);		//
				//    ٨
				m_wndDockBar.SetButtonInfo( 1, ID_NEXT_SEARCH, TBBS_BUTTON, 8 );
				//      
				m_wndDockBar.m_SearchBox.SendMessage(WM_COMMAND,ID_FIND,0);
			};
		};
	}
  else
  {
		ReadMainSettings(szMainSection);
		m_wndDockBar.m_SearchBox.EnableWindow();
    eFindMode = Off;
		SetNewContent(CurStih,CurTopic);
		//    ٨ 
		m_wndDockBar.SetButtonInfo( 1, ID_NEXT, TBBS_BUTTON, 1 );
  };
};

void CToolWnd::OnUpdateFind(CCmdUI* pCmdUI) 
{
	BOOL Checked = TRUE;
	
	if (eFindMode == Off)
			Checked = FALSE;

	pCmdUI->SetCheck(Checked);
}

void CToolWnd::OnAbout() 
{
	if (AnyDialogShow)
		return;
	
	AnyDialogShow = TRUE;
	CAbout AboutDlg(this);
	
	BOOL ShowTmp = Show;
	Show = FALSE;
	
	AboutDlg.DoModal();

	Show = ShowTmp;
	AnyDialogShow = FALSE;
}

BOOL CToolWnd::OnQueryEndSession() 
{
/*	//  
	WriteMainSettings(szMainSection);
	//  
	WINDOWPLACEMENT wp;
	wp.length = sizeof wp;
	if (GetWindowPlacement(&wp))
	{
		wp.flags = 0;
		if (IsZoomed())
			wp.flags |= WPF_RESTORETOMAXIMIZED;
		// and write it to the .INI file
		WriteWindowPlacement(szSection,&wp);
	};
	*/
	OnDestroy();

	if (!CMiniFrameWnd::OnQueryEndSession())
		return FALSE;
	
	return TRUE;
}

void CToolWnd::OnSkins() 
{
	CString SkinFilePath = m_wndDockBar.GetBtnSkinFilePath();
	
	CSkinDlg SkinDlg(this,&SkinFilePath);
	
	SkinDlg.DoModal();

	
}

BOOL CToolWnd::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if (pHelpInfo->iContextType == HELPINFO_WINDOW)
	{
		return HtmlHelp(	(HWND)pHelpInfo->hItemHandle,AfxGetApp()->m_pszHelpFilePath,
						HH_HELP_CONTEXT, IDH_TOOLWND) != NULL;
	}
	return TRUE;
//	return CMiniFrameWnd::OnHelpInfo(pHelpInfo);
}
