// editbar.h : header file
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#ifndef CEditBar_INCLUDED
#define CEditBar_INCLUDED

#include "searchbx.h"
/////////////////////////////////////////////////////////////////////////////
// CEditBar window

class CEditBar : public CToolBar
{
// Construction
public:
	BOOL m_bColor;
	CSearchBox m_SearchBox;

	CEditBar();
	BOOL Init(CWnd* pParentWnd, BOOL bColor, BOOL bToolTips);
	BOOL SetColor(BOOL bColor);
	BOOL SetHorizontal();
	BOOL SetVertical();

// Attributes
private:
	//      
	CString m_SkinFilePath;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditBar)
	//}}AFX_VIRTUAL

// Implementation
public:
	// m_SkinFilePath
	CString GetBtnSkinFilePath();
	//   .       
	//nIDResource. m_SkinFilePath   NULL
	void SetBtnSkinRes(UINT nIDResource,int iNumBtns);
	
	//       FilePath.  
	//          
	//   .        FilePath
	//  m_SkinFilePath
	void SetBtnSkinFile(CString FilePath, int iNumBtns);
	
	//          
	//  . ToolBitmap    .
	//  -  , iNumBtns -    
	BOOL SetBtnSkin(CBitmap &ToolBitmap, int iNumBtns);
	BOOL m_bVertical;
		
	virtual ~CEditBar();
//  virtual CSize CalcFixedLayout(BOOL bStretch, BOOL bHorz);
	virtual CSize CalcDynamicLayout(int nLength, DWORD dwMode);

private:
	//   
	void HideSeparators(CDC *pDC);
	//    CBrush    
	//   
	CBrush* GetBackgroundBrush();

	// Generated message map functions
protected:
	//{{AFX_MSG(CEditBar)
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif
/////////////////////////////////////////////////////////////////////////////
