// searchbx.cpp : implementation file
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "stdafx.h"
//#include "docktool.h"
#include "searchbx.h"
#include "resource.h"
#include "garikihelp.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#define STORE_COUNT 4
static TCHAR BASED_CODE szLBSection[] = _T("Last find");
/////////////////////////////////////////////////////////////////////////////
// CSearchBox

CSearchBox::CSearchBox()
{
}

CSearchBox::~CSearchBox()
{
}

BEGIN_MESSAGE_MAP(CSearchBox, CComboBox)
	//{{AFX_MSG_MAP(CSearchBox)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_COMMAND(ID_FIND, OnFind)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSearchBox message handlers

BOOL CSearchBox::PreTranslateMessage(MSG* pMsg)
{
	if ((pMsg->message != WM_KEYDOWN) || (pMsg->wParam != VK_RETURN))
		return CComboBox::PreTranslateMessage(pMsg);

	if ((pMsg->lParam & 0x40000000) == 0)   // Not a repeat.
		::PostMessage(GetParent()->m_hWnd,WM_COMMAND,ID_FIND,0);

	return TRUE;
}

void CSearchBox::OnFind() 
{
	// when the enter key is hit in the ComboBox we want to add the string
	// to the top of the list and hilight it.  We also want to limit the
	// list to the last 15 entries.
		CString strText;
		GetWindowText(strText);

		CString FirstText;
		int n = GetLBTextLen( 0 );
    GetLBText( 0, FirstText.GetBuffer(n) );
    FirstText.ReleaseBuffer();

		if (FirstText != strText)
		{
			InsertString(0, strText);
			SetCurSel(0);
			if (GetCount() > 15)
				DeleteString(GetCount()-1);
		};
}

void CSearchBox::WriteItems(LPCSTR szSection,int nCount)
{
   CString str, sKeyName;
   int n;

   for (int i=0;i < nCount;i++)
   {
      n = GetLBTextLen( i );
			if (n == CB_ERR)
				return;

      GetLBText( i, str.GetBuffer(n) );
			str.ReleaseBuffer();
			sKeyName.Format("String%i",i);
			AfxGetApp()->WriteProfileString(szSection, sKeyName, str);
   }
}

void CSearchBox::ReadItems(LPCSTR szSection,int nCount)
{
	CString str, sKeyName;

  for (int i=0;i < nCount;i++)
  {
		sKeyName.Format("String%i",i);
		str = AfxGetApp()->GetProfileString(szSection, sKeyName);
		if (str.IsEmpty())
			return;
		
		InsertString(i,str);
   }
}

int CSearchBox::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CComboBox::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	ReadItems(szLBSection,STORE_COUNT);

	return 0;
}

void CSearchBox::OnDestroy() 
{
	WriteItems(szLBSection,STORE_COUNT);

	CComboBox::OnDestroy();
}


BOOL CSearchBox::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if (pHelpInfo->iContextType == HELPINFO_WINDOW)
	{
		return HtmlHelp(	(HWND)pHelpInfo->hItemHandle,AfxGetApp()->m_pszHelpFilePath,
						HH_HELP_CONTEXT, IDH_FIND) != NULL;
	}
	return TRUE;		
//	return CComboBox::OnHelpInfo(pHelpInfo);
}
